<?php
/**
 * HistoryDayObj
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Weather Source History API
 *
 * Daily and hourly historical weather data for latitude/longitude points, Zip/Postal Codes, Designated Market Areas, and OnPoint™ points. The Weather Source History API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate analysis. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  An API key is required to authorize requests. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/).
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * HistoryDayObj Class Doc Comment
 *
 * @category Class
 * @description A daily weather history object.
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class HistoryDayObj implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'historyDayObj';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'date' => '\Swagger\Client\Model\\DateTime',
'provisional_flag' => '\Swagger\Client\Model\ProvisionalFlag',
'cld_cvr_min' => '\Swagger\Client\Model\CldCvrMin',
'cld_cvr_avg' => '\Swagger\Client\Model\CldCvrAvg',
'cld_cvr_max' => '\Swagger\Client\Model\CldCvrMax',
'dew_pt_min' => '\Swagger\Client\Model\DewPtMin',
'dew_pt_avg' => '\Swagger\Client\Model\DewPtAvg',
'dew_pt_max' => '\Swagger\Client\Model\DewPtMax',
'feels_like_min' => '\Swagger\Client\Model\FeelsLikeMin',
'feels_like_avg' => '\Swagger\Client\Model\FeelsLikeAvg',
'feels_like_max' => '\Swagger\Client\Model\FeelsLikeMax',
'heat_index_min' => '\Swagger\Client\Model\HeatIndexMin',
'heat_index_avg' => '\Swagger\Client\Model\HeatIndexAvg',
'heat_index_max' => '\Swagger\Client\Model\HeatIndexMax',
'msl_pres_min' => '\Swagger\Client\Model\MslPresMin',
'msl_pres_avg' => '\Swagger\Client\Model\MslPresAvg',
'msl_pres_max' => '\Swagger\Client\Model\MslPresMax',
'precip' => '\Swagger\Client\Model\Precip',
'pres_tend_min' => '\Swagger\Client\Model\PresTendMin',
'pres_tend_avg' => '\Swagger\Client\Model\PresTendAvg',
'pres_tend_max' => '\Swagger\Client\Model\PresTendMax',
'rad_solar_min' => '\Swagger\Client\Model\RadSolarMin',
'rad_solar_avg' => '\Swagger\Client\Model\RadSolarAvg',
'rad_solar_max' => '\Swagger\Client\Model\RadSolarMax',
'rad_solar_tot' => '\Swagger\Client\Model\RadSolarTot',
'rel_hum_min' => '\Swagger\Client\Model\RelHumMin',
'rel_hum_avg' => '\Swagger\Client\Model\RelHumAvg',
'rel_hum_max' => '\Swagger\Client\Model\RelHumMax',
'sfc_pres_min' => '\Swagger\Client\Model\SfcPresMin',
'sfc_pres_avg' => '\Swagger\Client\Model\SfcPresAvg',
'sfc_pres_max' => '\Swagger\Client\Model\SfcPresMax',
'snow_depth' => '\Swagger\Client\Model\SnowDepth',
'snowfall' => '\Swagger\Client\Model\Snowfall',
'spc_hum_min' => '\Swagger\Client\Model\SpcHumMin',
'spc_hum_avg' => '\Swagger\Client\Model\SpcHumAvg',
'spc_hum_max' => '\Swagger\Client\Model\SpcHumMax',
'temp_min' => '\Swagger\Client\Model\TempMin',
'temp_avg' => '\Swagger\Client\Model\TempAvg',
'temp_max' => '\Swagger\Client\Model\TempMax',
'vis_min' => '\Swagger\Client\Model\VisMin',
'vis_avg' => '\Swagger\Client\Model\VisAvg',
'vis_max' => '\Swagger\Client\Model\VisMax',
'wet_bulb_min' => '\Swagger\Client\Model\WetBulbMin',
'wet_bulb_avg' => '\Swagger\Client\Model\WetBulbAvg',
'wet_bulb_max' => '\Swagger\Client\Model\WetBulbMax',
'wind_chill_min' => '\Swagger\Client\Model\WindChillMin',
'wind_chill_avg' => '\Swagger\Client\Model\WindChillAvg',
'wind_chill_max' => '\Swagger\Client\Model\WindChillMax',
'wind_dir_avg' => '\Swagger\Client\Model\WindDirAvg',
'wind_dir80m_avg' => '\Swagger\Client\Model\WindDir80mAvg',
'wind_dir100m_avg' => '\Swagger\Client\Model\WindDir100mAvg',
'wind_spd_min' => '\Swagger\Client\Model\WindSpdMin',
'wind_spd_avg' => '\Swagger\Client\Model\WindSpdAvg',
'wind_spd_max' => '\Swagger\Client\Model\WindSpdMax',
'wind_spd80m_min' => '\Swagger\Client\Model\WindSpd80mMin',
'wind_spd80m_avg' => '\Swagger\Client\Model\WindSpd80mAvg',
'wind_spd80m_max' => '\Swagger\Client\Model\WindSpd80mMax',
'wind_spd100m_min' => '\Swagger\Client\Model\WindSpd100mMin',
'wind_spd100m_avg' => '\Swagger\Client\Model\WindSpd100mAvg',
'wind_spd100m_max' => '\Swagger\Client\Model\WindSpd100mMax',
'precip_hour_cnt' => '\Swagger\Client\Model\PrecipHourCnt',
'snowfall_hour_cnt' => '\Swagger\Client\Model\SnowfallHourCnt',
'freezing_rain_flag_cnt' => '\Swagger\Client\Model\FreezingRainFlagCnt',
'ice_pellets_flag_cnt' => '\Swagger\Client\Model\IcePelletsFlagCnt',
'rain_flag_cnt' => '\Swagger\Client\Model\RainFlagCnt',
'snow_flag_cnt' => '\Swagger\Client\Model\SnowFlagCnt'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'date' => null,
'provisional_flag' => null,
'cld_cvr_min' => null,
'cld_cvr_avg' => null,
'cld_cvr_max' => null,
'dew_pt_min' => null,
'dew_pt_avg' => null,
'dew_pt_max' => null,
'feels_like_min' => null,
'feels_like_avg' => null,
'feels_like_max' => null,
'heat_index_min' => null,
'heat_index_avg' => null,
'heat_index_max' => null,
'msl_pres_min' => null,
'msl_pres_avg' => null,
'msl_pres_max' => null,
'precip' => null,
'pres_tend_min' => null,
'pres_tend_avg' => null,
'pres_tend_max' => null,
'rad_solar_min' => null,
'rad_solar_avg' => null,
'rad_solar_max' => null,
'rad_solar_tot' => null,
'rel_hum_min' => null,
'rel_hum_avg' => null,
'rel_hum_max' => null,
'sfc_pres_min' => null,
'sfc_pres_avg' => null,
'sfc_pres_max' => null,
'snow_depth' => null,
'snowfall' => null,
'spc_hum_min' => null,
'spc_hum_avg' => null,
'spc_hum_max' => null,
'temp_min' => null,
'temp_avg' => null,
'temp_max' => null,
'vis_min' => null,
'vis_avg' => null,
'vis_max' => null,
'wet_bulb_min' => null,
'wet_bulb_avg' => null,
'wet_bulb_max' => null,
'wind_chill_min' => null,
'wind_chill_avg' => null,
'wind_chill_max' => null,
'wind_dir_avg' => null,
'wind_dir80m_avg' => null,
'wind_dir100m_avg' => null,
'wind_spd_min' => null,
'wind_spd_avg' => null,
'wind_spd_max' => null,
'wind_spd80m_min' => null,
'wind_spd80m_avg' => null,
'wind_spd80m_max' => null,
'wind_spd100m_min' => null,
'wind_spd100m_avg' => null,
'wind_spd100m_max' => null,
'precip_hour_cnt' => null,
'snowfall_hour_cnt' => null,
'freezing_rain_flag_cnt' => null,
'ice_pellets_flag_cnt' => null,
'rain_flag_cnt' => null,
'snow_flag_cnt' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'date' => 'date',
'provisional_flag' => 'provisionalFlag',
'cld_cvr_min' => 'cldCvrMin',
'cld_cvr_avg' => 'cldCvrAvg',
'cld_cvr_max' => 'cldCvrMax',
'dew_pt_min' => 'dewPtMin',
'dew_pt_avg' => 'dewPtAvg',
'dew_pt_max' => 'dewPtMax',
'feels_like_min' => 'feelsLikeMin',
'feels_like_avg' => 'feelsLikeAvg',
'feels_like_max' => 'feelsLikeMax',
'heat_index_min' => 'heatIndexMin',
'heat_index_avg' => 'heatIndexAvg',
'heat_index_max' => 'heatIndexMax',
'msl_pres_min' => 'mslPresMin',
'msl_pres_avg' => 'mslPresAvg',
'msl_pres_max' => 'mslPresMax',
'precip' => 'precip',
'pres_tend_min' => 'presTendMin',
'pres_tend_avg' => 'presTendAvg',
'pres_tend_max' => 'presTendMax',
'rad_solar_min' => 'radSolarMin',
'rad_solar_avg' => 'radSolarAvg',
'rad_solar_max' => 'radSolarMax',
'rad_solar_tot' => 'radSolarTot',
'rel_hum_min' => 'relHumMin',
'rel_hum_avg' => 'relHumAvg',
'rel_hum_max' => 'relHumMax',
'sfc_pres_min' => 'sfcPresMin',
'sfc_pres_avg' => 'sfcPresAvg',
'sfc_pres_max' => 'sfcPresMax',
'snow_depth' => 'snowDepth',
'snowfall' => 'snowfall',
'spc_hum_min' => 'spcHumMin',
'spc_hum_avg' => 'spcHumAvg',
'spc_hum_max' => 'spcHumMax',
'temp_min' => 'tempMin',
'temp_avg' => 'tempAvg',
'temp_max' => 'tempMax',
'vis_min' => 'visMin',
'vis_avg' => 'visAvg',
'vis_max' => 'visMax',
'wet_bulb_min' => 'wetBulbMin',
'wet_bulb_avg' => 'wetBulbAvg',
'wet_bulb_max' => 'wetBulbMax',
'wind_chill_min' => 'windChillMin',
'wind_chill_avg' => 'windChillAvg',
'wind_chill_max' => 'windChillMax',
'wind_dir_avg' => 'windDirAvg',
'wind_dir80m_avg' => 'windDir80mAvg',
'wind_dir100m_avg' => 'windDir100mAvg',
'wind_spd_min' => 'windSpdMin',
'wind_spd_avg' => 'windSpdAvg',
'wind_spd_max' => 'windSpdMax',
'wind_spd80m_min' => 'windSpd80mMin',
'wind_spd80m_avg' => 'windSpd80mAvg',
'wind_spd80m_max' => 'windSpd80mMax',
'wind_spd100m_min' => 'windSpd100mMin',
'wind_spd100m_avg' => 'windSpd100mAvg',
'wind_spd100m_max' => 'windSpd100mMax',
'precip_hour_cnt' => 'precipHourCnt',
'snowfall_hour_cnt' => 'snowfallHourCnt',
'freezing_rain_flag_cnt' => 'freezingRainFlagCnt',
'ice_pellets_flag_cnt' => 'icePelletsFlagCnt',
'rain_flag_cnt' => 'rainFlagCnt',
'snow_flag_cnt' => 'snowFlagCnt'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'date' => 'setDate',
'provisional_flag' => 'setProvisionalFlag',
'cld_cvr_min' => 'setCldCvrMin',
'cld_cvr_avg' => 'setCldCvrAvg',
'cld_cvr_max' => 'setCldCvrMax',
'dew_pt_min' => 'setDewPtMin',
'dew_pt_avg' => 'setDewPtAvg',
'dew_pt_max' => 'setDewPtMax',
'feels_like_min' => 'setFeelsLikeMin',
'feels_like_avg' => 'setFeelsLikeAvg',
'feels_like_max' => 'setFeelsLikeMax',
'heat_index_min' => 'setHeatIndexMin',
'heat_index_avg' => 'setHeatIndexAvg',
'heat_index_max' => 'setHeatIndexMax',
'msl_pres_min' => 'setMslPresMin',
'msl_pres_avg' => 'setMslPresAvg',
'msl_pres_max' => 'setMslPresMax',
'precip' => 'setPrecip',
'pres_tend_min' => 'setPresTendMin',
'pres_tend_avg' => 'setPresTendAvg',
'pres_tend_max' => 'setPresTendMax',
'rad_solar_min' => 'setRadSolarMin',
'rad_solar_avg' => 'setRadSolarAvg',
'rad_solar_max' => 'setRadSolarMax',
'rad_solar_tot' => 'setRadSolarTot',
'rel_hum_min' => 'setRelHumMin',
'rel_hum_avg' => 'setRelHumAvg',
'rel_hum_max' => 'setRelHumMax',
'sfc_pres_min' => 'setSfcPresMin',
'sfc_pres_avg' => 'setSfcPresAvg',
'sfc_pres_max' => 'setSfcPresMax',
'snow_depth' => 'setSnowDepth',
'snowfall' => 'setSnowfall',
'spc_hum_min' => 'setSpcHumMin',
'spc_hum_avg' => 'setSpcHumAvg',
'spc_hum_max' => 'setSpcHumMax',
'temp_min' => 'setTempMin',
'temp_avg' => 'setTempAvg',
'temp_max' => 'setTempMax',
'vis_min' => 'setVisMin',
'vis_avg' => 'setVisAvg',
'vis_max' => 'setVisMax',
'wet_bulb_min' => 'setWetBulbMin',
'wet_bulb_avg' => 'setWetBulbAvg',
'wet_bulb_max' => 'setWetBulbMax',
'wind_chill_min' => 'setWindChillMin',
'wind_chill_avg' => 'setWindChillAvg',
'wind_chill_max' => 'setWindChillMax',
'wind_dir_avg' => 'setWindDirAvg',
'wind_dir80m_avg' => 'setWindDir80mAvg',
'wind_dir100m_avg' => 'setWindDir100mAvg',
'wind_spd_min' => 'setWindSpdMin',
'wind_spd_avg' => 'setWindSpdAvg',
'wind_spd_max' => 'setWindSpdMax',
'wind_spd80m_min' => 'setWindSpd80mMin',
'wind_spd80m_avg' => 'setWindSpd80mAvg',
'wind_spd80m_max' => 'setWindSpd80mMax',
'wind_spd100m_min' => 'setWindSpd100mMin',
'wind_spd100m_avg' => 'setWindSpd100mAvg',
'wind_spd100m_max' => 'setWindSpd100mMax',
'precip_hour_cnt' => 'setPrecipHourCnt',
'snowfall_hour_cnt' => 'setSnowfallHourCnt',
'freezing_rain_flag_cnt' => 'setFreezingRainFlagCnt',
'ice_pellets_flag_cnt' => 'setIcePelletsFlagCnt',
'rain_flag_cnt' => 'setRainFlagCnt',
'snow_flag_cnt' => 'setSnowFlagCnt'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'date' => 'getDate',
'provisional_flag' => 'getProvisionalFlag',
'cld_cvr_min' => 'getCldCvrMin',
'cld_cvr_avg' => 'getCldCvrAvg',
'cld_cvr_max' => 'getCldCvrMax',
'dew_pt_min' => 'getDewPtMin',
'dew_pt_avg' => 'getDewPtAvg',
'dew_pt_max' => 'getDewPtMax',
'feels_like_min' => 'getFeelsLikeMin',
'feels_like_avg' => 'getFeelsLikeAvg',
'feels_like_max' => 'getFeelsLikeMax',
'heat_index_min' => 'getHeatIndexMin',
'heat_index_avg' => 'getHeatIndexAvg',
'heat_index_max' => 'getHeatIndexMax',
'msl_pres_min' => 'getMslPresMin',
'msl_pres_avg' => 'getMslPresAvg',
'msl_pres_max' => 'getMslPresMax',
'precip' => 'getPrecip',
'pres_tend_min' => 'getPresTendMin',
'pres_tend_avg' => 'getPresTendAvg',
'pres_tend_max' => 'getPresTendMax',
'rad_solar_min' => 'getRadSolarMin',
'rad_solar_avg' => 'getRadSolarAvg',
'rad_solar_max' => 'getRadSolarMax',
'rad_solar_tot' => 'getRadSolarTot',
'rel_hum_min' => 'getRelHumMin',
'rel_hum_avg' => 'getRelHumAvg',
'rel_hum_max' => 'getRelHumMax',
'sfc_pres_min' => 'getSfcPresMin',
'sfc_pres_avg' => 'getSfcPresAvg',
'sfc_pres_max' => 'getSfcPresMax',
'snow_depth' => 'getSnowDepth',
'snowfall' => 'getSnowfall',
'spc_hum_min' => 'getSpcHumMin',
'spc_hum_avg' => 'getSpcHumAvg',
'spc_hum_max' => 'getSpcHumMax',
'temp_min' => 'getTempMin',
'temp_avg' => 'getTempAvg',
'temp_max' => 'getTempMax',
'vis_min' => 'getVisMin',
'vis_avg' => 'getVisAvg',
'vis_max' => 'getVisMax',
'wet_bulb_min' => 'getWetBulbMin',
'wet_bulb_avg' => 'getWetBulbAvg',
'wet_bulb_max' => 'getWetBulbMax',
'wind_chill_min' => 'getWindChillMin',
'wind_chill_avg' => 'getWindChillAvg',
'wind_chill_max' => 'getWindChillMax',
'wind_dir_avg' => 'getWindDirAvg',
'wind_dir80m_avg' => 'getWindDir80mAvg',
'wind_dir100m_avg' => 'getWindDir100mAvg',
'wind_spd_min' => 'getWindSpdMin',
'wind_spd_avg' => 'getWindSpdAvg',
'wind_spd_max' => 'getWindSpdMax',
'wind_spd80m_min' => 'getWindSpd80mMin',
'wind_spd80m_avg' => 'getWindSpd80mAvg',
'wind_spd80m_max' => 'getWindSpd80mMax',
'wind_spd100m_min' => 'getWindSpd100mMin',
'wind_spd100m_avg' => 'getWindSpd100mAvg',
'wind_spd100m_max' => 'getWindSpd100mMax',
'precip_hour_cnt' => 'getPrecipHourCnt',
'snowfall_hour_cnt' => 'getSnowfallHourCnt',
'freezing_rain_flag_cnt' => 'getFreezingRainFlagCnt',
'ice_pellets_flag_cnt' => 'getIcePelletsFlagCnt',
'rain_flag_cnt' => 'getRainFlagCnt',
'snow_flag_cnt' => 'getSnowFlagCnt'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['date'] = isset($data['date']) ? $data['date'] : null;
        $this->container['provisional_flag'] = isset($data['provisional_flag']) ? $data['provisional_flag'] : null;
        $this->container['cld_cvr_min'] = isset($data['cld_cvr_min']) ? $data['cld_cvr_min'] : null;
        $this->container['cld_cvr_avg'] = isset($data['cld_cvr_avg']) ? $data['cld_cvr_avg'] : null;
        $this->container['cld_cvr_max'] = isset($data['cld_cvr_max']) ? $data['cld_cvr_max'] : null;
        $this->container['dew_pt_min'] = isset($data['dew_pt_min']) ? $data['dew_pt_min'] : null;
        $this->container['dew_pt_avg'] = isset($data['dew_pt_avg']) ? $data['dew_pt_avg'] : null;
        $this->container['dew_pt_max'] = isset($data['dew_pt_max']) ? $data['dew_pt_max'] : null;
        $this->container['feels_like_min'] = isset($data['feels_like_min']) ? $data['feels_like_min'] : null;
        $this->container['feels_like_avg'] = isset($data['feels_like_avg']) ? $data['feels_like_avg'] : null;
        $this->container['feels_like_max'] = isset($data['feels_like_max']) ? $data['feels_like_max'] : null;
        $this->container['heat_index_min'] = isset($data['heat_index_min']) ? $data['heat_index_min'] : null;
        $this->container['heat_index_avg'] = isset($data['heat_index_avg']) ? $data['heat_index_avg'] : null;
        $this->container['heat_index_max'] = isset($data['heat_index_max']) ? $data['heat_index_max'] : null;
        $this->container['msl_pres_min'] = isset($data['msl_pres_min']) ? $data['msl_pres_min'] : null;
        $this->container['msl_pres_avg'] = isset($data['msl_pres_avg']) ? $data['msl_pres_avg'] : null;
        $this->container['msl_pres_max'] = isset($data['msl_pres_max']) ? $data['msl_pres_max'] : null;
        $this->container['precip'] = isset($data['precip']) ? $data['precip'] : null;
        $this->container['pres_tend_min'] = isset($data['pres_tend_min']) ? $data['pres_tend_min'] : null;
        $this->container['pres_tend_avg'] = isset($data['pres_tend_avg']) ? $data['pres_tend_avg'] : null;
        $this->container['pres_tend_max'] = isset($data['pres_tend_max']) ? $data['pres_tend_max'] : null;
        $this->container['rad_solar_min'] = isset($data['rad_solar_min']) ? $data['rad_solar_min'] : null;
        $this->container['rad_solar_avg'] = isset($data['rad_solar_avg']) ? $data['rad_solar_avg'] : null;
        $this->container['rad_solar_max'] = isset($data['rad_solar_max']) ? $data['rad_solar_max'] : null;
        $this->container['rad_solar_tot'] = isset($data['rad_solar_tot']) ? $data['rad_solar_tot'] : null;
        $this->container['rel_hum_min'] = isset($data['rel_hum_min']) ? $data['rel_hum_min'] : null;
        $this->container['rel_hum_avg'] = isset($data['rel_hum_avg']) ? $data['rel_hum_avg'] : null;
        $this->container['rel_hum_max'] = isset($data['rel_hum_max']) ? $data['rel_hum_max'] : null;
        $this->container['sfc_pres_min'] = isset($data['sfc_pres_min']) ? $data['sfc_pres_min'] : null;
        $this->container['sfc_pres_avg'] = isset($data['sfc_pres_avg']) ? $data['sfc_pres_avg'] : null;
        $this->container['sfc_pres_max'] = isset($data['sfc_pres_max']) ? $data['sfc_pres_max'] : null;
        $this->container['snow_depth'] = isset($data['snow_depth']) ? $data['snow_depth'] : null;
        $this->container['snowfall'] = isset($data['snowfall']) ? $data['snowfall'] : null;
        $this->container['spc_hum_min'] = isset($data['spc_hum_min']) ? $data['spc_hum_min'] : null;
        $this->container['spc_hum_avg'] = isset($data['spc_hum_avg']) ? $data['spc_hum_avg'] : null;
        $this->container['spc_hum_max'] = isset($data['spc_hum_max']) ? $data['spc_hum_max'] : null;
        $this->container['temp_min'] = isset($data['temp_min']) ? $data['temp_min'] : null;
        $this->container['temp_avg'] = isset($data['temp_avg']) ? $data['temp_avg'] : null;
        $this->container['temp_max'] = isset($data['temp_max']) ? $data['temp_max'] : null;
        $this->container['vis_min'] = isset($data['vis_min']) ? $data['vis_min'] : null;
        $this->container['vis_avg'] = isset($data['vis_avg']) ? $data['vis_avg'] : null;
        $this->container['vis_max'] = isset($data['vis_max']) ? $data['vis_max'] : null;
        $this->container['wet_bulb_min'] = isset($data['wet_bulb_min']) ? $data['wet_bulb_min'] : null;
        $this->container['wet_bulb_avg'] = isset($data['wet_bulb_avg']) ? $data['wet_bulb_avg'] : null;
        $this->container['wet_bulb_max'] = isset($data['wet_bulb_max']) ? $data['wet_bulb_max'] : null;
        $this->container['wind_chill_min'] = isset($data['wind_chill_min']) ? $data['wind_chill_min'] : null;
        $this->container['wind_chill_avg'] = isset($data['wind_chill_avg']) ? $data['wind_chill_avg'] : null;
        $this->container['wind_chill_max'] = isset($data['wind_chill_max']) ? $data['wind_chill_max'] : null;
        $this->container['wind_dir_avg'] = isset($data['wind_dir_avg']) ? $data['wind_dir_avg'] : null;
        $this->container['wind_dir80m_avg'] = isset($data['wind_dir80m_avg']) ? $data['wind_dir80m_avg'] : null;
        $this->container['wind_dir100m_avg'] = isset($data['wind_dir100m_avg']) ? $data['wind_dir100m_avg'] : null;
        $this->container['wind_spd_min'] = isset($data['wind_spd_min']) ? $data['wind_spd_min'] : null;
        $this->container['wind_spd_avg'] = isset($data['wind_spd_avg']) ? $data['wind_spd_avg'] : null;
        $this->container['wind_spd_max'] = isset($data['wind_spd_max']) ? $data['wind_spd_max'] : null;
        $this->container['wind_spd80m_min'] = isset($data['wind_spd80m_min']) ? $data['wind_spd80m_min'] : null;
        $this->container['wind_spd80m_avg'] = isset($data['wind_spd80m_avg']) ? $data['wind_spd80m_avg'] : null;
        $this->container['wind_spd80m_max'] = isset($data['wind_spd80m_max']) ? $data['wind_spd80m_max'] : null;
        $this->container['wind_spd100m_min'] = isset($data['wind_spd100m_min']) ? $data['wind_spd100m_min'] : null;
        $this->container['wind_spd100m_avg'] = isset($data['wind_spd100m_avg']) ? $data['wind_spd100m_avg'] : null;
        $this->container['wind_spd100m_max'] = isset($data['wind_spd100m_max']) ? $data['wind_spd100m_max'] : null;
        $this->container['precip_hour_cnt'] = isset($data['precip_hour_cnt']) ? $data['precip_hour_cnt'] : null;
        $this->container['snowfall_hour_cnt'] = isset($data['snowfall_hour_cnt']) ? $data['snowfall_hour_cnt'] : null;
        $this->container['freezing_rain_flag_cnt'] = isset($data['freezing_rain_flag_cnt']) ? $data['freezing_rain_flag_cnt'] : null;
        $this->container['ice_pellets_flag_cnt'] = isset($data['ice_pellets_flag_cnt']) ? $data['ice_pellets_flag_cnt'] : null;
        $this->container['rain_flag_cnt'] = isset($data['rain_flag_cnt']) ? $data['rain_flag_cnt'] : null;
        $this->container['snow_flag_cnt'] = isset($data['snow_flag_cnt']) ? $data['snow_flag_cnt'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['date'] === null) {
            $invalidProperties[] = "'date' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets date
     *
     * @return \Swagger\Client\Model\\DateTime
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param \Swagger\Client\Model\\DateTime $date date
     *
     * @return $this
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets provisional_flag
     *
     * @return \Swagger\Client\Model\ProvisionalFlag
     */
    public function getProvisionalFlag()
    {
        return $this->container['provisional_flag'];
    }

    /**
     * Sets provisional_flag
     *
     * @param \Swagger\Client\Model\ProvisionalFlag $provisional_flag provisional_flag
     *
     * @return $this
     */
    public function setProvisionalFlag($provisional_flag)
    {
        $this->container['provisional_flag'] = $provisional_flag;

        return $this;
    }

    /**
     * Gets cld_cvr_min
     *
     * @return \Swagger\Client\Model\CldCvrMin
     */
    public function getCldCvrMin()
    {
        return $this->container['cld_cvr_min'];
    }

    /**
     * Sets cld_cvr_min
     *
     * @param \Swagger\Client\Model\CldCvrMin $cld_cvr_min cld_cvr_min
     *
     * @return $this
     */
    public function setCldCvrMin($cld_cvr_min)
    {
        $this->container['cld_cvr_min'] = $cld_cvr_min;

        return $this;
    }

    /**
     * Gets cld_cvr_avg
     *
     * @return \Swagger\Client\Model\CldCvrAvg
     */
    public function getCldCvrAvg()
    {
        return $this->container['cld_cvr_avg'];
    }

    /**
     * Sets cld_cvr_avg
     *
     * @param \Swagger\Client\Model\CldCvrAvg $cld_cvr_avg cld_cvr_avg
     *
     * @return $this
     */
    public function setCldCvrAvg($cld_cvr_avg)
    {
        $this->container['cld_cvr_avg'] = $cld_cvr_avg;

        return $this;
    }

    /**
     * Gets cld_cvr_max
     *
     * @return \Swagger\Client\Model\CldCvrMax
     */
    public function getCldCvrMax()
    {
        return $this->container['cld_cvr_max'];
    }

    /**
     * Sets cld_cvr_max
     *
     * @param \Swagger\Client\Model\CldCvrMax $cld_cvr_max cld_cvr_max
     *
     * @return $this
     */
    public function setCldCvrMax($cld_cvr_max)
    {
        $this->container['cld_cvr_max'] = $cld_cvr_max;

        return $this;
    }

    /**
     * Gets dew_pt_min
     *
     * @return \Swagger\Client\Model\DewPtMin
     */
    public function getDewPtMin()
    {
        return $this->container['dew_pt_min'];
    }

    /**
     * Sets dew_pt_min
     *
     * @param \Swagger\Client\Model\DewPtMin $dew_pt_min dew_pt_min
     *
     * @return $this
     */
    public function setDewPtMin($dew_pt_min)
    {
        $this->container['dew_pt_min'] = $dew_pt_min;

        return $this;
    }

    /**
     * Gets dew_pt_avg
     *
     * @return \Swagger\Client\Model\DewPtAvg
     */
    public function getDewPtAvg()
    {
        return $this->container['dew_pt_avg'];
    }

    /**
     * Sets dew_pt_avg
     *
     * @param \Swagger\Client\Model\DewPtAvg $dew_pt_avg dew_pt_avg
     *
     * @return $this
     */
    public function setDewPtAvg($dew_pt_avg)
    {
        $this->container['dew_pt_avg'] = $dew_pt_avg;

        return $this;
    }

    /**
     * Gets dew_pt_max
     *
     * @return \Swagger\Client\Model\DewPtMax
     */
    public function getDewPtMax()
    {
        return $this->container['dew_pt_max'];
    }

    /**
     * Sets dew_pt_max
     *
     * @param \Swagger\Client\Model\DewPtMax $dew_pt_max dew_pt_max
     *
     * @return $this
     */
    public function setDewPtMax($dew_pt_max)
    {
        $this->container['dew_pt_max'] = $dew_pt_max;

        return $this;
    }

    /**
     * Gets feels_like_min
     *
     * @return \Swagger\Client\Model\FeelsLikeMin
     */
    public function getFeelsLikeMin()
    {
        return $this->container['feels_like_min'];
    }

    /**
     * Sets feels_like_min
     *
     * @param \Swagger\Client\Model\FeelsLikeMin $feels_like_min feels_like_min
     *
     * @return $this
     */
    public function setFeelsLikeMin($feels_like_min)
    {
        $this->container['feels_like_min'] = $feels_like_min;

        return $this;
    }

    /**
     * Gets feels_like_avg
     *
     * @return \Swagger\Client\Model\FeelsLikeAvg
     */
    public function getFeelsLikeAvg()
    {
        return $this->container['feels_like_avg'];
    }

    /**
     * Sets feels_like_avg
     *
     * @param \Swagger\Client\Model\FeelsLikeAvg $feels_like_avg feels_like_avg
     *
     * @return $this
     */
    public function setFeelsLikeAvg($feels_like_avg)
    {
        $this->container['feels_like_avg'] = $feels_like_avg;

        return $this;
    }

    /**
     * Gets feels_like_max
     *
     * @return \Swagger\Client\Model\FeelsLikeMax
     */
    public function getFeelsLikeMax()
    {
        return $this->container['feels_like_max'];
    }

    /**
     * Sets feels_like_max
     *
     * @param \Swagger\Client\Model\FeelsLikeMax $feels_like_max feels_like_max
     *
     * @return $this
     */
    public function setFeelsLikeMax($feels_like_max)
    {
        $this->container['feels_like_max'] = $feels_like_max;

        return $this;
    }

    /**
     * Gets heat_index_min
     *
     * @return \Swagger\Client\Model\HeatIndexMin
     */
    public function getHeatIndexMin()
    {
        return $this->container['heat_index_min'];
    }

    /**
     * Sets heat_index_min
     *
     * @param \Swagger\Client\Model\HeatIndexMin $heat_index_min heat_index_min
     *
     * @return $this
     */
    public function setHeatIndexMin($heat_index_min)
    {
        $this->container['heat_index_min'] = $heat_index_min;

        return $this;
    }

    /**
     * Gets heat_index_avg
     *
     * @return \Swagger\Client\Model\HeatIndexAvg
     */
    public function getHeatIndexAvg()
    {
        return $this->container['heat_index_avg'];
    }

    /**
     * Sets heat_index_avg
     *
     * @param \Swagger\Client\Model\HeatIndexAvg $heat_index_avg heat_index_avg
     *
     * @return $this
     */
    public function setHeatIndexAvg($heat_index_avg)
    {
        $this->container['heat_index_avg'] = $heat_index_avg;

        return $this;
    }

    /**
     * Gets heat_index_max
     *
     * @return \Swagger\Client\Model\HeatIndexMax
     */
    public function getHeatIndexMax()
    {
        return $this->container['heat_index_max'];
    }

    /**
     * Sets heat_index_max
     *
     * @param \Swagger\Client\Model\HeatIndexMax $heat_index_max heat_index_max
     *
     * @return $this
     */
    public function setHeatIndexMax($heat_index_max)
    {
        $this->container['heat_index_max'] = $heat_index_max;

        return $this;
    }

    /**
     * Gets msl_pres_min
     *
     * @return \Swagger\Client\Model\MslPresMin
     */
    public function getMslPresMin()
    {
        return $this->container['msl_pres_min'];
    }

    /**
     * Sets msl_pres_min
     *
     * @param \Swagger\Client\Model\MslPresMin $msl_pres_min msl_pres_min
     *
     * @return $this
     */
    public function setMslPresMin($msl_pres_min)
    {
        $this->container['msl_pres_min'] = $msl_pres_min;

        return $this;
    }

    /**
     * Gets msl_pres_avg
     *
     * @return \Swagger\Client\Model\MslPresAvg
     */
    public function getMslPresAvg()
    {
        return $this->container['msl_pres_avg'];
    }

    /**
     * Sets msl_pres_avg
     *
     * @param \Swagger\Client\Model\MslPresAvg $msl_pres_avg msl_pres_avg
     *
     * @return $this
     */
    public function setMslPresAvg($msl_pres_avg)
    {
        $this->container['msl_pres_avg'] = $msl_pres_avg;

        return $this;
    }

    /**
     * Gets msl_pres_max
     *
     * @return \Swagger\Client\Model\MslPresMax
     */
    public function getMslPresMax()
    {
        return $this->container['msl_pres_max'];
    }

    /**
     * Sets msl_pres_max
     *
     * @param \Swagger\Client\Model\MslPresMax $msl_pres_max msl_pres_max
     *
     * @return $this
     */
    public function setMslPresMax($msl_pres_max)
    {
        $this->container['msl_pres_max'] = $msl_pres_max;

        return $this;
    }

    /**
     * Gets precip
     *
     * @return \Swagger\Client\Model\Precip
     */
    public function getPrecip()
    {
        return $this->container['precip'];
    }

    /**
     * Sets precip
     *
     * @param \Swagger\Client\Model\Precip $precip precip
     *
     * @return $this
     */
    public function setPrecip($precip)
    {
        $this->container['precip'] = $precip;

        return $this;
    }

    /**
     * Gets pres_tend_min
     *
     * @return \Swagger\Client\Model\PresTendMin
     */
    public function getPresTendMin()
    {
        return $this->container['pres_tend_min'];
    }

    /**
     * Sets pres_tend_min
     *
     * @param \Swagger\Client\Model\PresTendMin $pres_tend_min pres_tend_min
     *
     * @return $this
     */
    public function setPresTendMin($pres_tend_min)
    {
        $this->container['pres_tend_min'] = $pres_tend_min;

        return $this;
    }

    /**
     * Gets pres_tend_avg
     *
     * @return \Swagger\Client\Model\PresTendAvg
     */
    public function getPresTendAvg()
    {
        return $this->container['pres_tend_avg'];
    }

    /**
     * Sets pres_tend_avg
     *
     * @param \Swagger\Client\Model\PresTendAvg $pres_tend_avg pres_tend_avg
     *
     * @return $this
     */
    public function setPresTendAvg($pres_tend_avg)
    {
        $this->container['pres_tend_avg'] = $pres_tend_avg;

        return $this;
    }

    /**
     * Gets pres_tend_max
     *
     * @return \Swagger\Client\Model\PresTendMax
     */
    public function getPresTendMax()
    {
        return $this->container['pres_tend_max'];
    }

    /**
     * Sets pres_tend_max
     *
     * @param \Swagger\Client\Model\PresTendMax $pres_tend_max pres_tend_max
     *
     * @return $this
     */
    public function setPresTendMax($pres_tend_max)
    {
        $this->container['pres_tend_max'] = $pres_tend_max;

        return $this;
    }

    /**
     * Gets rad_solar_min
     *
     * @return \Swagger\Client\Model\RadSolarMin
     */
    public function getRadSolarMin()
    {
        return $this->container['rad_solar_min'];
    }

    /**
     * Sets rad_solar_min
     *
     * @param \Swagger\Client\Model\RadSolarMin $rad_solar_min rad_solar_min
     *
     * @return $this
     */
    public function setRadSolarMin($rad_solar_min)
    {
        $this->container['rad_solar_min'] = $rad_solar_min;

        return $this;
    }

    /**
     * Gets rad_solar_avg
     *
     * @return \Swagger\Client\Model\RadSolarAvg
     */
    public function getRadSolarAvg()
    {
        return $this->container['rad_solar_avg'];
    }

    /**
     * Sets rad_solar_avg
     *
     * @param \Swagger\Client\Model\RadSolarAvg $rad_solar_avg rad_solar_avg
     *
     * @return $this
     */
    public function setRadSolarAvg($rad_solar_avg)
    {
        $this->container['rad_solar_avg'] = $rad_solar_avg;

        return $this;
    }

    /**
     * Gets rad_solar_max
     *
     * @return \Swagger\Client\Model\RadSolarMax
     */
    public function getRadSolarMax()
    {
        return $this->container['rad_solar_max'];
    }

    /**
     * Sets rad_solar_max
     *
     * @param \Swagger\Client\Model\RadSolarMax $rad_solar_max rad_solar_max
     *
     * @return $this
     */
    public function setRadSolarMax($rad_solar_max)
    {
        $this->container['rad_solar_max'] = $rad_solar_max;

        return $this;
    }

    /**
     * Gets rad_solar_tot
     *
     * @return \Swagger\Client\Model\RadSolarTot
     */
    public function getRadSolarTot()
    {
        return $this->container['rad_solar_tot'];
    }

    /**
     * Sets rad_solar_tot
     *
     * @param \Swagger\Client\Model\RadSolarTot $rad_solar_tot rad_solar_tot
     *
     * @return $this
     */
    public function setRadSolarTot($rad_solar_tot)
    {
        $this->container['rad_solar_tot'] = $rad_solar_tot;

        return $this;
    }

    /**
     * Gets rel_hum_min
     *
     * @return \Swagger\Client\Model\RelHumMin
     */
    public function getRelHumMin()
    {
        return $this->container['rel_hum_min'];
    }

    /**
     * Sets rel_hum_min
     *
     * @param \Swagger\Client\Model\RelHumMin $rel_hum_min rel_hum_min
     *
     * @return $this
     */
    public function setRelHumMin($rel_hum_min)
    {
        $this->container['rel_hum_min'] = $rel_hum_min;

        return $this;
    }

    /**
     * Gets rel_hum_avg
     *
     * @return \Swagger\Client\Model\RelHumAvg
     */
    public function getRelHumAvg()
    {
        return $this->container['rel_hum_avg'];
    }

    /**
     * Sets rel_hum_avg
     *
     * @param \Swagger\Client\Model\RelHumAvg $rel_hum_avg rel_hum_avg
     *
     * @return $this
     */
    public function setRelHumAvg($rel_hum_avg)
    {
        $this->container['rel_hum_avg'] = $rel_hum_avg;

        return $this;
    }

    /**
     * Gets rel_hum_max
     *
     * @return \Swagger\Client\Model\RelHumMax
     */
    public function getRelHumMax()
    {
        return $this->container['rel_hum_max'];
    }

    /**
     * Sets rel_hum_max
     *
     * @param \Swagger\Client\Model\RelHumMax $rel_hum_max rel_hum_max
     *
     * @return $this
     */
    public function setRelHumMax($rel_hum_max)
    {
        $this->container['rel_hum_max'] = $rel_hum_max;

        return $this;
    }

    /**
     * Gets sfc_pres_min
     *
     * @return \Swagger\Client\Model\SfcPresMin
     */
    public function getSfcPresMin()
    {
        return $this->container['sfc_pres_min'];
    }

    /**
     * Sets sfc_pres_min
     *
     * @param \Swagger\Client\Model\SfcPresMin $sfc_pres_min sfc_pres_min
     *
     * @return $this
     */
    public function setSfcPresMin($sfc_pres_min)
    {
        $this->container['sfc_pres_min'] = $sfc_pres_min;

        return $this;
    }

    /**
     * Gets sfc_pres_avg
     *
     * @return \Swagger\Client\Model\SfcPresAvg
     */
    public function getSfcPresAvg()
    {
        return $this->container['sfc_pres_avg'];
    }

    /**
     * Sets sfc_pres_avg
     *
     * @param \Swagger\Client\Model\SfcPresAvg $sfc_pres_avg sfc_pres_avg
     *
     * @return $this
     */
    public function setSfcPresAvg($sfc_pres_avg)
    {
        $this->container['sfc_pres_avg'] = $sfc_pres_avg;

        return $this;
    }

    /**
     * Gets sfc_pres_max
     *
     * @return \Swagger\Client\Model\SfcPresMax
     */
    public function getSfcPresMax()
    {
        return $this->container['sfc_pres_max'];
    }

    /**
     * Sets sfc_pres_max
     *
     * @param \Swagger\Client\Model\SfcPresMax $sfc_pres_max sfc_pres_max
     *
     * @return $this
     */
    public function setSfcPresMax($sfc_pres_max)
    {
        $this->container['sfc_pres_max'] = $sfc_pres_max;

        return $this;
    }

    /**
     * Gets snow_depth
     *
     * @return \Swagger\Client\Model\SnowDepth
     */
    public function getSnowDepth()
    {
        return $this->container['snow_depth'];
    }

    /**
     * Sets snow_depth
     *
     * @param \Swagger\Client\Model\SnowDepth $snow_depth snow_depth
     *
     * @return $this
     */
    public function setSnowDepth($snow_depth)
    {
        $this->container['snow_depth'] = $snow_depth;

        return $this;
    }

    /**
     * Gets snowfall
     *
     * @return \Swagger\Client\Model\Snowfall
     */
    public function getSnowfall()
    {
        return $this->container['snowfall'];
    }

    /**
     * Sets snowfall
     *
     * @param \Swagger\Client\Model\Snowfall $snowfall snowfall
     *
     * @return $this
     */
    public function setSnowfall($snowfall)
    {
        $this->container['snowfall'] = $snowfall;

        return $this;
    }

    /**
     * Gets spc_hum_min
     *
     * @return \Swagger\Client\Model\SpcHumMin
     */
    public function getSpcHumMin()
    {
        return $this->container['spc_hum_min'];
    }

    /**
     * Sets spc_hum_min
     *
     * @param \Swagger\Client\Model\SpcHumMin $spc_hum_min spc_hum_min
     *
     * @return $this
     */
    public function setSpcHumMin($spc_hum_min)
    {
        $this->container['spc_hum_min'] = $spc_hum_min;

        return $this;
    }

    /**
     * Gets spc_hum_avg
     *
     * @return \Swagger\Client\Model\SpcHumAvg
     */
    public function getSpcHumAvg()
    {
        return $this->container['spc_hum_avg'];
    }

    /**
     * Sets spc_hum_avg
     *
     * @param \Swagger\Client\Model\SpcHumAvg $spc_hum_avg spc_hum_avg
     *
     * @return $this
     */
    public function setSpcHumAvg($spc_hum_avg)
    {
        $this->container['spc_hum_avg'] = $spc_hum_avg;

        return $this;
    }

    /**
     * Gets spc_hum_max
     *
     * @return \Swagger\Client\Model\SpcHumMax
     */
    public function getSpcHumMax()
    {
        return $this->container['spc_hum_max'];
    }

    /**
     * Sets spc_hum_max
     *
     * @param \Swagger\Client\Model\SpcHumMax $spc_hum_max spc_hum_max
     *
     * @return $this
     */
    public function setSpcHumMax($spc_hum_max)
    {
        $this->container['spc_hum_max'] = $spc_hum_max;

        return $this;
    }

    /**
     * Gets temp_min
     *
     * @return \Swagger\Client\Model\TempMin
     */
    public function getTempMin()
    {
        return $this->container['temp_min'];
    }

    /**
     * Sets temp_min
     *
     * @param \Swagger\Client\Model\TempMin $temp_min temp_min
     *
     * @return $this
     */
    public function setTempMin($temp_min)
    {
        $this->container['temp_min'] = $temp_min;

        return $this;
    }

    /**
     * Gets temp_avg
     *
     * @return \Swagger\Client\Model\TempAvg
     */
    public function getTempAvg()
    {
        return $this->container['temp_avg'];
    }

    /**
     * Sets temp_avg
     *
     * @param \Swagger\Client\Model\TempAvg $temp_avg temp_avg
     *
     * @return $this
     */
    public function setTempAvg($temp_avg)
    {
        $this->container['temp_avg'] = $temp_avg;

        return $this;
    }

    /**
     * Gets temp_max
     *
     * @return \Swagger\Client\Model\TempMax
     */
    public function getTempMax()
    {
        return $this->container['temp_max'];
    }

    /**
     * Sets temp_max
     *
     * @param \Swagger\Client\Model\TempMax $temp_max temp_max
     *
     * @return $this
     */
    public function setTempMax($temp_max)
    {
        $this->container['temp_max'] = $temp_max;

        return $this;
    }

    /**
     * Gets vis_min
     *
     * @return \Swagger\Client\Model\VisMin
     */
    public function getVisMin()
    {
        return $this->container['vis_min'];
    }

    /**
     * Sets vis_min
     *
     * @param \Swagger\Client\Model\VisMin $vis_min vis_min
     *
     * @return $this
     */
    public function setVisMin($vis_min)
    {
        $this->container['vis_min'] = $vis_min;

        return $this;
    }

    /**
     * Gets vis_avg
     *
     * @return \Swagger\Client\Model\VisAvg
     */
    public function getVisAvg()
    {
        return $this->container['vis_avg'];
    }

    /**
     * Sets vis_avg
     *
     * @param \Swagger\Client\Model\VisAvg $vis_avg vis_avg
     *
     * @return $this
     */
    public function setVisAvg($vis_avg)
    {
        $this->container['vis_avg'] = $vis_avg;

        return $this;
    }

    /**
     * Gets vis_max
     *
     * @return \Swagger\Client\Model\VisMax
     */
    public function getVisMax()
    {
        return $this->container['vis_max'];
    }

    /**
     * Sets vis_max
     *
     * @param \Swagger\Client\Model\VisMax $vis_max vis_max
     *
     * @return $this
     */
    public function setVisMax($vis_max)
    {
        $this->container['vis_max'] = $vis_max;

        return $this;
    }

    /**
     * Gets wet_bulb_min
     *
     * @return \Swagger\Client\Model\WetBulbMin
     */
    public function getWetBulbMin()
    {
        return $this->container['wet_bulb_min'];
    }

    /**
     * Sets wet_bulb_min
     *
     * @param \Swagger\Client\Model\WetBulbMin $wet_bulb_min wet_bulb_min
     *
     * @return $this
     */
    public function setWetBulbMin($wet_bulb_min)
    {
        $this->container['wet_bulb_min'] = $wet_bulb_min;

        return $this;
    }

    /**
     * Gets wet_bulb_avg
     *
     * @return \Swagger\Client\Model\WetBulbAvg
     */
    public function getWetBulbAvg()
    {
        return $this->container['wet_bulb_avg'];
    }

    /**
     * Sets wet_bulb_avg
     *
     * @param \Swagger\Client\Model\WetBulbAvg $wet_bulb_avg wet_bulb_avg
     *
     * @return $this
     */
    public function setWetBulbAvg($wet_bulb_avg)
    {
        $this->container['wet_bulb_avg'] = $wet_bulb_avg;

        return $this;
    }

    /**
     * Gets wet_bulb_max
     *
     * @return \Swagger\Client\Model\WetBulbMax
     */
    public function getWetBulbMax()
    {
        return $this->container['wet_bulb_max'];
    }

    /**
     * Sets wet_bulb_max
     *
     * @param \Swagger\Client\Model\WetBulbMax $wet_bulb_max wet_bulb_max
     *
     * @return $this
     */
    public function setWetBulbMax($wet_bulb_max)
    {
        $this->container['wet_bulb_max'] = $wet_bulb_max;

        return $this;
    }

    /**
     * Gets wind_chill_min
     *
     * @return \Swagger\Client\Model\WindChillMin
     */
    public function getWindChillMin()
    {
        return $this->container['wind_chill_min'];
    }

    /**
     * Sets wind_chill_min
     *
     * @param \Swagger\Client\Model\WindChillMin $wind_chill_min wind_chill_min
     *
     * @return $this
     */
    public function setWindChillMin($wind_chill_min)
    {
        $this->container['wind_chill_min'] = $wind_chill_min;

        return $this;
    }

    /**
     * Gets wind_chill_avg
     *
     * @return \Swagger\Client\Model\WindChillAvg
     */
    public function getWindChillAvg()
    {
        return $this->container['wind_chill_avg'];
    }

    /**
     * Sets wind_chill_avg
     *
     * @param \Swagger\Client\Model\WindChillAvg $wind_chill_avg wind_chill_avg
     *
     * @return $this
     */
    public function setWindChillAvg($wind_chill_avg)
    {
        $this->container['wind_chill_avg'] = $wind_chill_avg;

        return $this;
    }

    /**
     * Gets wind_chill_max
     *
     * @return \Swagger\Client\Model\WindChillMax
     */
    public function getWindChillMax()
    {
        return $this->container['wind_chill_max'];
    }

    /**
     * Sets wind_chill_max
     *
     * @param \Swagger\Client\Model\WindChillMax $wind_chill_max wind_chill_max
     *
     * @return $this
     */
    public function setWindChillMax($wind_chill_max)
    {
        $this->container['wind_chill_max'] = $wind_chill_max;

        return $this;
    }

    /**
     * Gets wind_dir_avg
     *
     * @return \Swagger\Client\Model\WindDirAvg
     */
    public function getWindDirAvg()
    {
        return $this->container['wind_dir_avg'];
    }

    /**
     * Sets wind_dir_avg
     *
     * @param \Swagger\Client\Model\WindDirAvg $wind_dir_avg wind_dir_avg
     *
     * @return $this
     */
    public function setWindDirAvg($wind_dir_avg)
    {
        $this->container['wind_dir_avg'] = $wind_dir_avg;

        return $this;
    }

    /**
     * Gets wind_dir80m_avg
     *
     * @return \Swagger\Client\Model\WindDir80mAvg
     */
    public function getWindDir80mAvg()
    {
        return $this->container['wind_dir80m_avg'];
    }

    /**
     * Sets wind_dir80m_avg
     *
     * @param \Swagger\Client\Model\WindDir80mAvg $wind_dir80m_avg wind_dir80m_avg
     *
     * @return $this
     */
    public function setWindDir80mAvg($wind_dir80m_avg)
    {
        $this->container['wind_dir80m_avg'] = $wind_dir80m_avg;

        return $this;
    }

    /**
     * Gets wind_dir100m_avg
     *
     * @return \Swagger\Client\Model\WindDir100mAvg
     */
    public function getWindDir100mAvg()
    {
        return $this->container['wind_dir100m_avg'];
    }

    /**
     * Sets wind_dir100m_avg
     *
     * @param \Swagger\Client\Model\WindDir100mAvg $wind_dir100m_avg wind_dir100m_avg
     *
     * @return $this
     */
    public function setWindDir100mAvg($wind_dir100m_avg)
    {
        $this->container['wind_dir100m_avg'] = $wind_dir100m_avg;

        return $this;
    }

    /**
     * Gets wind_spd_min
     *
     * @return \Swagger\Client\Model\WindSpdMin
     */
    public function getWindSpdMin()
    {
        return $this->container['wind_spd_min'];
    }

    /**
     * Sets wind_spd_min
     *
     * @param \Swagger\Client\Model\WindSpdMin $wind_spd_min wind_spd_min
     *
     * @return $this
     */
    public function setWindSpdMin($wind_spd_min)
    {
        $this->container['wind_spd_min'] = $wind_spd_min;

        return $this;
    }

    /**
     * Gets wind_spd_avg
     *
     * @return \Swagger\Client\Model\WindSpdAvg
     */
    public function getWindSpdAvg()
    {
        return $this->container['wind_spd_avg'];
    }

    /**
     * Sets wind_spd_avg
     *
     * @param \Swagger\Client\Model\WindSpdAvg $wind_spd_avg wind_spd_avg
     *
     * @return $this
     */
    public function setWindSpdAvg($wind_spd_avg)
    {
        $this->container['wind_spd_avg'] = $wind_spd_avg;

        return $this;
    }

    /**
     * Gets wind_spd_max
     *
     * @return \Swagger\Client\Model\WindSpdMax
     */
    public function getWindSpdMax()
    {
        return $this->container['wind_spd_max'];
    }

    /**
     * Sets wind_spd_max
     *
     * @param \Swagger\Client\Model\WindSpdMax $wind_spd_max wind_spd_max
     *
     * @return $this
     */
    public function setWindSpdMax($wind_spd_max)
    {
        $this->container['wind_spd_max'] = $wind_spd_max;

        return $this;
    }

    /**
     * Gets wind_spd80m_min
     *
     * @return \Swagger\Client\Model\WindSpd80mMin
     */
    public function getWindSpd80mMin()
    {
        return $this->container['wind_spd80m_min'];
    }

    /**
     * Sets wind_spd80m_min
     *
     * @param \Swagger\Client\Model\WindSpd80mMin $wind_spd80m_min wind_spd80m_min
     *
     * @return $this
     */
    public function setWindSpd80mMin($wind_spd80m_min)
    {
        $this->container['wind_spd80m_min'] = $wind_spd80m_min;

        return $this;
    }

    /**
     * Gets wind_spd80m_avg
     *
     * @return \Swagger\Client\Model\WindSpd80mAvg
     */
    public function getWindSpd80mAvg()
    {
        return $this->container['wind_spd80m_avg'];
    }

    /**
     * Sets wind_spd80m_avg
     *
     * @param \Swagger\Client\Model\WindSpd80mAvg $wind_spd80m_avg wind_spd80m_avg
     *
     * @return $this
     */
    public function setWindSpd80mAvg($wind_spd80m_avg)
    {
        $this->container['wind_spd80m_avg'] = $wind_spd80m_avg;

        return $this;
    }

    /**
     * Gets wind_spd80m_max
     *
     * @return \Swagger\Client\Model\WindSpd80mMax
     */
    public function getWindSpd80mMax()
    {
        return $this->container['wind_spd80m_max'];
    }

    /**
     * Sets wind_spd80m_max
     *
     * @param \Swagger\Client\Model\WindSpd80mMax $wind_spd80m_max wind_spd80m_max
     *
     * @return $this
     */
    public function setWindSpd80mMax($wind_spd80m_max)
    {
        $this->container['wind_spd80m_max'] = $wind_spd80m_max;

        return $this;
    }

    /**
     * Gets wind_spd100m_min
     *
     * @return \Swagger\Client\Model\WindSpd100mMin
     */
    public function getWindSpd100mMin()
    {
        return $this->container['wind_spd100m_min'];
    }

    /**
     * Sets wind_spd100m_min
     *
     * @param \Swagger\Client\Model\WindSpd100mMin $wind_spd100m_min wind_spd100m_min
     *
     * @return $this
     */
    public function setWindSpd100mMin($wind_spd100m_min)
    {
        $this->container['wind_spd100m_min'] = $wind_spd100m_min;

        return $this;
    }

    /**
     * Gets wind_spd100m_avg
     *
     * @return \Swagger\Client\Model\WindSpd100mAvg
     */
    public function getWindSpd100mAvg()
    {
        return $this->container['wind_spd100m_avg'];
    }

    /**
     * Sets wind_spd100m_avg
     *
     * @param \Swagger\Client\Model\WindSpd100mAvg $wind_spd100m_avg wind_spd100m_avg
     *
     * @return $this
     */
    public function setWindSpd100mAvg($wind_spd100m_avg)
    {
        $this->container['wind_spd100m_avg'] = $wind_spd100m_avg;

        return $this;
    }

    /**
     * Gets wind_spd100m_max
     *
     * @return \Swagger\Client\Model\WindSpd100mMax
     */
    public function getWindSpd100mMax()
    {
        return $this->container['wind_spd100m_max'];
    }

    /**
     * Sets wind_spd100m_max
     *
     * @param \Swagger\Client\Model\WindSpd100mMax $wind_spd100m_max wind_spd100m_max
     *
     * @return $this
     */
    public function setWindSpd100mMax($wind_spd100m_max)
    {
        $this->container['wind_spd100m_max'] = $wind_spd100m_max;

        return $this;
    }

    /**
     * Gets precip_hour_cnt
     *
     * @return \Swagger\Client\Model\PrecipHourCnt
     */
    public function getPrecipHourCnt()
    {
        return $this->container['precip_hour_cnt'];
    }

    /**
     * Sets precip_hour_cnt
     *
     * @param \Swagger\Client\Model\PrecipHourCnt $precip_hour_cnt precip_hour_cnt
     *
     * @return $this
     */
    public function setPrecipHourCnt($precip_hour_cnt)
    {
        $this->container['precip_hour_cnt'] = $precip_hour_cnt;

        return $this;
    }

    /**
     * Gets snowfall_hour_cnt
     *
     * @return \Swagger\Client\Model\SnowfallHourCnt
     */
    public function getSnowfallHourCnt()
    {
        return $this->container['snowfall_hour_cnt'];
    }

    /**
     * Sets snowfall_hour_cnt
     *
     * @param \Swagger\Client\Model\SnowfallHourCnt $snowfall_hour_cnt snowfall_hour_cnt
     *
     * @return $this
     */
    public function setSnowfallHourCnt($snowfall_hour_cnt)
    {
        $this->container['snowfall_hour_cnt'] = $snowfall_hour_cnt;

        return $this;
    }

    /**
     * Gets freezing_rain_flag_cnt
     *
     * @return \Swagger\Client\Model\FreezingRainFlagCnt
     */
    public function getFreezingRainFlagCnt()
    {
        return $this->container['freezing_rain_flag_cnt'];
    }

    /**
     * Sets freezing_rain_flag_cnt
     *
     * @param \Swagger\Client\Model\FreezingRainFlagCnt $freezing_rain_flag_cnt freezing_rain_flag_cnt
     *
     * @return $this
     */
    public function setFreezingRainFlagCnt($freezing_rain_flag_cnt)
    {
        $this->container['freezing_rain_flag_cnt'] = $freezing_rain_flag_cnt;

        return $this;
    }

    /**
     * Gets ice_pellets_flag_cnt
     *
     * @return \Swagger\Client\Model\IcePelletsFlagCnt
     */
    public function getIcePelletsFlagCnt()
    {
        return $this->container['ice_pellets_flag_cnt'];
    }

    /**
     * Sets ice_pellets_flag_cnt
     *
     * @param \Swagger\Client\Model\IcePelletsFlagCnt $ice_pellets_flag_cnt ice_pellets_flag_cnt
     *
     * @return $this
     */
    public function setIcePelletsFlagCnt($ice_pellets_flag_cnt)
    {
        $this->container['ice_pellets_flag_cnt'] = $ice_pellets_flag_cnt;

        return $this;
    }

    /**
     * Gets rain_flag_cnt
     *
     * @return \Swagger\Client\Model\RainFlagCnt
     */
    public function getRainFlagCnt()
    {
        return $this->container['rain_flag_cnt'];
    }

    /**
     * Sets rain_flag_cnt
     *
     * @param \Swagger\Client\Model\RainFlagCnt $rain_flag_cnt rain_flag_cnt
     *
     * @return $this
     */
    public function setRainFlagCnt($rain_flag_cnt)
    {
        $this->container['rain_flag_cnt'] = $rain_flag_cnt;

        return $this;
    }

    /**
     * Gets snow_flag_cnt
     *
     * @return \Swagger\Client\Model\SnowFlagCnt
     */
    public function getSnowFlagCnt()
    {
        return $this->container['snow_flag_cnt'];
    }

    /**
     * Sets snow_flag_cnt
     *
     * @param \Swagger\Client\Model\SnowFlagCnt $snow_flag_cnt snow_flag_cnt
     *
     * @return $this
     */
    public function setSnowFlagCnt($snow_flag_cnt)
    {
        $this->container['snow_flag_cnt'] = $snow_flag_cnt;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
